> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Release



## OpenAPI

````yaml /openapi.json post /v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions:
    post:
      tags:
        - Project Budget Versions
      summary: Release
      operationId: ProjectBudgetVersionsController_release_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d{0,18}$
        - name: projectId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d{0,18}$
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ReleaseProjectBudgetVersionDto'
      responses:
        '201':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectBudgetVersionDetailResponseDto'
      security:
        - bearer: []
components:
  schemas:
    ReleaseProjectBudgetVersionDto:
      type: object
      properties:
        expectedDraftVersion:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        expectedStructureVersion:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        expectedItemsFingerprint:
          type: string
          pattern: ^[a-f0-9]{64}$
        note:
          anyOf:
            - type: string
              maxLength: 160
            - type: 'null'
        idempotencyKey:
          type: string
          format: uuid
          pattern: >-
            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
      required:
        - expectedDraftVersion
        - expectedStructureVersion
        - expectedItemsFingerprint
        - idempotencyKey
      additionalProperties: false
    ProjectBudgetVersionDetailResponseDto:
      type: object
      properties:
        id:
          type: string
        number:
          type: number
        note:
          type:
            - string
            - 'null'
        releasedAt:
          format: date-time
          type: string
        releasedBy:
          $ref: '#/components/schemas/ProjectBudgetVersionActorResponseDto'
        archivedAt:
          format: date-time
          type:
            - string
            - 'null'
        summary:
          $ref: '#/components/schemas/ProjectBudgetVersionSummaryResponseDto'
        snapshot:
          $ref: '#/components/schemas/ProjectBudgetVersionSnapshotResponseDto'
      required:
        - id
        - number
        - note
        - releasedAt
        - releasedBy
        - archivedAt
        - summary
        - snapshot
    ProjectBudgetVersionActorResponseDto:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
      required:
        - id
        - name
    ProjectBudgetVersionSummaryResponseDto:
      type: object
      properties:
        ceiling:
          type:
            - string
            - 'null'
        targetMarginPct:
          type:
            - string
            - 'null'
        envelope:
          type:
            - string
            - 'null'
        hard:
          type:
            - string
            - 'null'
        allocated:
          type:
            - string
            - 'null'
        unallocated:
          type:
            - string
            - 'null'
    ProjectBudgetVersionSnapshotResponseDto:
      type: object
      properties:
        softCosts:
          anyOf:
            - $ref: '#/components/schemas/ProjectBudgetVersionSoftCostsResponseDto'
            - type: 'null'
        schema:
          type: number
        config:
          $ref: '#/components/schemas/ProjectBudgetVersionConfigResponseDto'
        derived:
          $ref: '#/components/schemas/ProjectBudgetVersionDerivedResponseDto'
        areas:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetVersionAreaResponseDto'
        categories:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetVersionCategoryResponseDto'
        segments:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetSegmentResponseDto'
        warnings:
          type: array
          items:
            type: string
            enum:
              - CEILING_MISSING
              - AREA_INPUTS_MISSING
              - BUDGET_SHORTFALL
              - OVER_ALLOCATED
      required:
        - softCosts
        - schema
        - config
        - derived
        - areas
        - categories
        - segments
        - warnings
    ProjectBudgetVersionSoftCostsResponseDto:
      type: object
      properties:
        itemsFingerprint:
          type: string
        itemCount:
          type: number
        records:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetVersionSoftCostRecordResponseDto'
      required:
        - itemCount
        - records
    ProjectBudgetVersionConfigResponseDto:
      type: object
      properties:
        softCostAllocations:
          type:
            - object
            - 'null'
          additionalProperties:
            type: string
        method:
          type: string
          enum:
            - manual
            - area_rates
        manualCeiling:
          type:
            - string
            - 'null'
        targetMarginPct:
          type:
            - string
            - 'null'
        contingencyPct:
          type:
            - string
            - 'null'
      required:
        - method
    ProjectBudgetVersionDerivedResponseDto:
      type: object
      properties:
        softCostBudgets:
          type:
            - object
            - 'null'
          additionalProperties:
            anyOf:
              - type: string
              - type: 'null'
        ceiling:
          type:
            - string
            - 'null'
        profit:
          type:
            - string
            - 'null'
        envelope:
          type:
            - string
            - 'null'
        hard:
          type:
            - string
            - 'null'
        contingency:
          type:
            - string
            - 'null'
        allocated:
          type:
            - string
            - 'null'
        unallocated:
          type:
            - string
            - 'null'
        softCostBudgetTotal:
          type:
            - string
            - 'null'
    ProjectBudgetVersionAreaResponseDto:
      type: object
      properties:
        areaId:
          type: string
        parentId:
          type:
            - string
            - 'null'
        depth:
          type: number
        order:
          type: number
        name:
          type: string
        instanceCount:
          type: number
        effectiveInstanceCount:
          type: number
        squareArea:
          type:
            - string
            - 'null'
        rate:
          type:
            - string
            - 'null'
        manualAmount:
          type:
            - string
            - 'null'
        own:
          type:
            - string
            - 'null'
        total:
          type: string
      required:
        - areaId
        - parentId
        - depth
        - order
        - name
        - instanceCount
        - effectiveInstanceCount
        - squareArea
    ProjectBudgetVersionCategoryResponseDto:
      type: object
      properties:
        softCostDefaults:
          type:
            - object
            - 'null'
          additionalProperties:
            type: string
        workspaceCategoryId:
          type: string
        name:
          type: string
        segmentKey:
          type:
            - string
            - 'null'
        segmentName:
          type:
            - string
            - 'null'
        rule:
          anyOf:
            - $ref: '#/components/schemas/ProjectBudgetCategoryRuleResponseDto'
            - type: 'null'
        allocation:
          type:
            - string
            - 'null'
        sharePct:
          type:
            - string
            - 'null'
        effectiveMarginPct:
          type:
            - string
            - 'null'
        marginOverridden:
          type:
            - boolean
            - 'null'
        defaultMarkupPct:
          type:
            - string
            - 'null'
        effectiveMarkupPct:
          type:
            - string
            - 'null'
        equivalentMarginPct:
          type:
            - string
            - 'null'
        markupFromProject:
          type:
            - boolean
            - 'null'
        sellAllocation:
          type:
            - string
            - 'null'
      required:
        - workspaceCategoryId
        - name
        - segmentKey
        - segmentName
    ProjectBudgetSegmentResponseDto:
      type: object
      properties:
        key:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        allocated:
          type: string
      required:
        - key
        - name
    ProjectBudgetVersionSoftCostRecordResponseDto:
      type: object
      properties:
        id:
          type: string
        typeId:
          type: string
        name:
          type: string
        archived:
          type: boolean
      required:
        - id
        - typeId
        - name
        - archived
    ProjectBudgetCategoryRuleResponseDto:
      type: object
      properties:
        mode:
          type: string
          enum:
            - percent
            - amount
        value:
          type: string
      required:
        - mode
        - value
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.